/*
 *     Copyright: Eugene M. Hutorny (c) 2009, eugene@hutorny.in.ua
 *     License:   Licensed to public under The GNU Lesser General Public License (LGPLv3) 
 *                http://www.opensource.org/licenses/lgpl-3.0.html
 */
package ua.in.hutorny.otj.exer1.bank;

import java.math.BigDecimal;

import ua.in.hutorny.otj.exer1.accounting.Account;
import ua.in.hutorny.otj.exer1.bank.Bank.BankAccount;
import ua.in.hutorny.otj.exer1.exeptions.NotEnoughFunds;
import ua.in.hutorny.otj.exer1.money.Currency;

/**
 * @author Eugene
 *
 */
team class WireTransferCollaboration2 extends BankCollaboration implements WireTransfer {

	public WireTransferCollaboration2(Bank bank, BankAccount creditAccount,double interest) {
		super(bank, creditAccount,interest);
	}

	@SuppressWarnings("bindingconventions")
	protected class DebitAccount playedBy Account {
		@SuppressWarnings("decapsulation")
		void debit(BigDecimal amount, Currency currency) -> void debit(BigDecimal amount); 
	}	
	
	private void withdraw(BigDecimal amount, BankAccount as CreditAccount creditAccount, Account as DebitAccount debitAccount,
			Bank as Operator operator, Bank as CurrencyConverter currencyConvertor) throws NotEnoughFunds {
		super.withdraw(amount, creditAccount, debitAccount, operator.operationalAccount(), currencyConvertor);
	}

	public void wireTo(Account debitAccount, int amount) throws NotEnoughFunds {
		if( debitAccount.currency() != account.currency() )
			throw new IllegalArgumentException("Debit account should have the same currency (" + account.currency() + ") as Credit account");		
		withdraw(new BigDecimal(amount), account, debitAccount, bank, bank);
	}

}
